controllers/SiteController.php
<?php

namespace app\controllers;

use app\services\Bug;
use app\services\Demand;
use app\services\LoginForm;
use app\services\OperationLog;
use app\services\Product;
use app\services\User;
use Yii;
use yii\helpers\Url;

class SiteController extends BaseController
{
    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }

    public function actionMain()
    {
        $product_overview = [
            'product_total' => count(Product::authProductId([10, 20])),
            'demand_total' => Demand::find()->joinWith(['product'])->where(['demand.develop_user_id' => \Yii::$app->user->identity->id, 'demand.status' => 10, 'demand.step' => [1, 2]])->count(),
            'bug_total' => Bug::find()->joinWith(['product'])->where(['bug.develop_user_id' => \Yii::$app->user->identity->id, 'bug.status' => 10, 'bug.step' => [1, 2]])->count(),
        ];
        $product_info = Product::productStatistics();
        return $this->render('main', ['product_info' => $product_info, 'product_overview' => $product_overview]);
    }

    /**
     * Login action.
     *
     * @return Response|string
     */
    public function actionLogin()
    {
        if (!Yii::$app->user->isGuest) {
            return $this->goHome();
        }

        $model = new LoginForm();
        if (Yii::$app->request->isPost) {
            $model->load(Yii::$app->request->post(), '');
            if ($model->login()) {
                $operation_log = new OperationLog();
                $operation_log->create($this, "登陆了系统");
                return $this->success(['url' => Yii::$app->getUser()->getReturnUrl()], '');
            } else {
                return $this->error($model->errors);
            }
        }

        return $this->render('login', [
            'model' => $model,
        ]);
    }

    public function actionLogout()
    {
        $operation_log = new OperationLog();
        $operation_log->create($this, "退出了系统");
        Yii::$app->user->logout();
        return $this->goHome();
    }

    public function actionError()
    {
        return $this->alert();
    }

    public function actionUpdatePassword()
    {
        $request = Yii::$app->request;
        $post = Yii::$app->request->post();

        if ($request->isPost) {
            $model = User::findIdentity(Yii::$app->user->identity->id);
            $model->load($request->post(), '');

            //如果填写了密码则修改密码
            if ($post['password_hash']) {
                if ($post['password_hash'] != $post['password_confirm']) {
                    return $this->error('两次输入的密码不同');
                }
                $model->setPassword($post['password_hash']);
            }

            $model->save();
            $model->operation_log->create($this, "修改了自己的用户信息", Url::to(['/organization/user/view', 'id' => $model->id]));
            return $this->success([], '信息修改成功');
        }

        $model = User::findIdentity(Yii::$app->user->identity->id);
        return $this->render('update-password', ['model' => $model]);
    }
}

views/site/alert.php
<div class="error-page">
    <img class="error-page-img" src="<?= Yii::$app->params['imagePath'] ?>/<?= $code ?: '404' ?>.png">
    <div class="error-page-info">
        <!--        <h1>--><? //= $code ?><!--</h1>-->
        <h1 style="font-size:3em"><?= $msg ?></h1>
    </div>
</div>

views/site/index.php
<?php

use yii\helpers\Url;

$this->title = Yii::$app->params['title'];
?>
<style>
    a {
        cursor: pointer
    }
</style>

<div class="layui-layout layui-layout-admin" style="position: relative">
    <div class="layui-row layui-bg-blue" id="LAY-app-nav">
        <div class="layui-col-xs12 layui-col-md3">
            <ul class="layui-nav layui-bg-blue">
                <li class="layui-nav-item" style="margin-right: 3px">
                    <i class="layui-icon layui-icon-shrink-right layui-show-xs-inline layui-show-sm-inline layui-hide-md layui-hide-bg"
                       id="nav-area-btn"></i>
                </li>
                <li class="layui-nav-item layui-hide-xs">
                    <?= Yii::$app->params['title']?>
                </li>

                <li class="layui-nav-item layui-hide layui-show-xs-inline">
                    产品管理系统
                </li>

                <li class="layui-nav-item layui-hide-md layui-hide-bg layui-show-xs-block layui-show-sm-block"
                    lay-unselect="" style="float: right;display: none;">
                    <a href="javascript:;"><?= Yii::$app->user->identity->realname ? Yii::$app->user->identity->realname : Yii::$app->user->identity->username ?></a>
                    <dl class="layui-nav-child">
                        <dd><a layui-href="<?= Url::to(['/site/update-password']) ?>">修改信息</a></dd>
                        <dd><a href="<?= Url::to(['/site/logout']) ?>">退出</a></dd>
                    </dl>
                </li>
                <li class="layui-nav-item layui-hide-md layui-hide-bg layui-show-xs-block layui-show-sm-block"
                    style="float: right;display: none;" lay-unselect="">
                    <a href="javascript:void(0)" onclick="openRecentNews()" style="padding: 0">
                        <i class="layui-icon layui-icon-notice"></i>
                    </a>
                </li>
            </ul>
        </div>

        <div class="layui-col-xs12 layui-col-md6" id="nav-area">
            <ul class="layui-nav layui-bg-blue">
                <?php foreach (\app\services\Menu::getMenu() as $key => $item): ?>
                    <li class="layui-nav-item <?= $key == 0 ? 'layui-this' : '' ?>">
                        <a <?php if ($item['url']): ?>layui-href="<?= $item['url'] ?>"<?php endif; ?>>
                            <?= $item['title'] ?>
                            <?php if (isset($item['badge']) && !empty($item['badge'])): ?>
                                <span class="layui-badge" data-url="<?= $item['badge'] ?>"
                                      title="<?= $item['badge_desc'] ?>"><i
                                            class="layui-anim layui-anim-rotate layui-anim-loop layui-icon layui-icon-loading"></i></span>
                            <?php endif; ?>
                        </a>
                        <?php if (isset($item['child'])): ?>
                            <dl class="layui-nav-child"> <!-- 二级菜单 -->
                                <?php foreach ($item['child'] as $child): ?>
                                    <dd>
                                        <a <?php if ($child['url']): ?>layui-href="<?= $child['url'] ?>"<?php endif; ?>><?= $child['title'] ?></a>
                                    </dd>
                                <?php endforeach; ?>
                            </dl>
                        <?php endif; ?>
                    </li>
                <?php endforeach; ?>
            </ul>
        </div>

        <div class="layui-col-md3 layui-hide-xs layui-hide-sm layui-show-md-block layui-show-bg-block">
            <ul class="layui-nav layui-bg-blue">

                <li class="layui-nav-item" lay-unselect="" style="float: right">
                    <a href="javascript:;"><?= Yii::$app->user->identity->realname ? Yii::$app->user->identity->realname : Yii::$app->user->identity->username ?></a>
                    <dl class="layui-nav-child">
                        <dd><a href="javascript:;" layui-href="<?= Url::to(['/site/update-password']) ?>">修改信息</a></dd>
                        <dd><a href="<?= Url::to(['/site/logout']) ?>">退出</a></dd>
                    </dl>
                </li>
                <li class="layui-nav-item" lay-unselect="" style="float: right;">
                    <a href="javascript:void(0)" onclick="openRecentNews()">
                        <i class="layui-icon layui-icon-notice"></i>
                        <span class="layui-badge" data-url="<?=  Url::to(['/common/badge/notice-count'])?>"
                              title="最新通知数"><i
                                    class="layui-anim layui-anim-rotate layui-anim-loop layui-icon layui-icon-loading"></i></span>
                    </a>
                </li>
            </ul>
        </div>
    </div>

    <!-- 主体内容-->
    <div class="layui-body" id="LAY_app_body" style="z-index: 0;">
        <div class="layadmin-tabsbody-item layui-show">
            <iframe src="<?= Url::to(['main']) ?>" frameborder="0" class="layadmin-iframe"></iframe>
        </div>
    </div>
</div>

<?php $this->beginBlock('js') ?>
<script>
    /**
     * 最新消息通知
     */
    function openRecentNews() {
        layui.layer.open({
            type: 2,
            id: 'LAY_adminPopupR',
            anim: -1,
            title: false,
            closeBtn: false,
            offset: 'r',
            shade: 0.1,
            shadeClose: true,
            skin: 'layui-anim layui-anim-rl layui-layer-adminRight layui-col-xs12 layui-col-sm6 layui-col-md4 layui-col-lg3',
            maxWidth: 450,
            content: "<?= Url::to(['/common/side/notice'])?>"
        });
    }

    /**
     * 兼容手机端尺寸，重计算body距离头部导航的偏移量
     */
    $(function () {
        $('#LAY_app_body').css('top', $('#LAY-app-nav').height());
    })

    $('#LAY-app-nav').resize(function () {
        $('#LAY_app_body').css('top', $('#LAY-app-nav').height());
    })

    /**
     * 点击菜单后重定向iframe body
     */
    $('a').click(function () {
        var url = $(this).attr('layui-href');
        if (url) {
            $('.layadmin-iframe').attr('src', url);
        }
    })

    /**
     * 点击隐藏菜单
     */
    $('#nav-area-btn').click(function () {
        $('#nav-area').toggleClass('hide');
        $(this).toggleClass('layui-icon-spread-left');
        $(this).toggleClass('layui-icon-shrink-right');
    })

    /**
     * 滑屏隐藏菜单栏，增加可视高度
     */
    // $(".layadmin-iframe").load(function () {
    //     var iframe = $(".layadmin-iframe").contents();
    //     $(iframe).bind('touchstart', function (e) {
    //         startX = e.originalEvent.changedTouches[0].pageX;
    //         startY = e.originalEvent.changedTouches[0].pageY;
    //     })
    //     $(iframe).bind('touchmove', function (e) {
    //         //获取滑动屏幕时的X,Y
    //         endX = e.originalEvent.changedTouches[0].pageX;
    //         endY = e.originalEvent.changedTouches[0].pageY;
    //         //获取滑动距离
    //         distanceX = endX - startX;
    //         distanceY = endY - startY;
    //         if (window_width < 992) {
    //             //判断滑动方向
    //             if (Math.abs(distanceX) > Math.abs(distanceY) && distanceX > 0) {
    //                 //向右滑动
    //             } else if (Math.abs(distanceX) > Math.abs(distanceY) && distanceX < 0) {
    //                 //向左滑动
    //             } else if (Math.abs(distanceX) < Math.abs(distanceY) && distanceY < 0) {
    //                 //向上滑动
    //                 $('#nav_area').hide();
    //             } else if (Math.abs(distanceX) < Math.abs(distanceY) && distanceY > 0) {
    //                 //向下滑动
    //                 $('#nav_area').show();
    //             } else {
    //                 //点击未滑动
    //             }
    //         }
    //     });
    // });

    /**
     * 每10秒拉取一次导航徽章状态
     */
    setInterval(function () {
        getBadge();
    }, 10000)

    getBadge();

    function getBadge() {
        var notice_count = 0;
        $('.layui-badge').each(function () {
            var that = $(this);
            $.ajax({
                type: "GET",
                url: that.data('url'),
                async: false,
                success: function (res) {
                    if (res.error == 1) {
                        that.html('?');
                    } else {
                        notice_count += res.data.count;
                        if (res.data.count > 99) {
                            that.html('99+');
                        } else {
                            that.html(res.data.count);
                        }
                    }
                }
            });
        })

        if (notice_count > 0) {
            document.title = '您有新的消息待确认';
        } else {
            document.title = '<?= Yii::$app->params['title']?>';
        }
    }
</script>
<?php $this->endBlock() ?>

views/site/login.php
<?php
$this->title = \Yii::$app->params['title'];
use yii\helpers\Url;

?>
    <link href="src/style/login.css" rel="stylesheet">
    <style>
        .layadmin-user-login {
            background: url('/images/background.jpg') no-repeat;
            background-size: cover;
        }

        @media screen and (max-width: 768px) {
            .layadmin-user-login-main {
                width: 300px;
                border: 0px;
                background: none;
            }
        }
    </style>

    <div class="layadmin-user-login layadmin-user-display-show">
        <div class="layadmin-user-login-main">
            <div class="layadmin-user-login-box layadmin-user-login-header">
                <h2>产品管理系统</h2>
                <p><?= \Yii::$app->params['title'] ?></p>
            </div>
            <form class="layui-form" action="<?= Url::to(['']) ?>" method="post">
                <div class="layadmin-user-login-box layadmin-user-login-body layui-form">
                    <div class="layui-form-item">
                        <label class="layadmin-user-login-icon layui-icon layui-icon-username"></label>
                        <input type="text" name="username" lay-verify="required" placeholder="用户名" class="layui-input">
                    </div>
                    <div class="layui-form-item">
                        <label class="layadmin-user-login-icon layui-icon layui-icon-password"
                               for="LAY-user-login-password"></label>
                        <input type="password" name="password" lay-verify="required" placeholder="密码"
                               class="layui-input">
                    </div>
                    <div class="layui-form-item">
                        <a href="javascript:;" class="layui-btn layui-btn-normal layui-btn-fluid ajax-submit" lay-submit
                           lay-filter="submit"
                           after-success="jump">登 入</a>
                    </div>
                </div>
            </form>
        </div>
    </div>

<?php $this->beginBlock('js') ?>
    <script type="text/javascript">
    </script>
<?php $this->endBlock() ?>

views/site/main.php
<?php
?>

<style>
    .layui-card-body {
        padding: 15px;
    }

    .produce-list li {
        height: 30px;
        line-height: 30px;
        padding-left: 10px;
        border-left: 3px solid rgba(30, 159, 255, 0);
        overflow: hidden;
        text-overflow: ellipsis;
        white-space: nowrap;
        cursor: pointer;
    }

    .li_this {
        border-left: 3px solid #1E9FFF !important;
        background: #F0F0F0;
    }

    .product-detail-view {
        padding-top: 20px;
        text-align: center;
    }
</style>

<div class="layui-fluid layui-anim layui-anim-fadein layui-col-md-offset1 layui-col-md10">
    <div class="layui-row layui-col-space10">
        <!--左边栏-->
        <div class="layui-col-sm8">
            <!--概况-->
            <?= $this->render('plug/overview', ['product_overview' => $product_overview]) ?>

            <!--产品统计-->
            <?= $this->render('plug/prod_statistics', ['product_info' => $product_info]) ?>
        </div>

        <!--右边栏-->
        <div class="layui-col-sm4">
            <!--最新动态-->
            <?= \app\components\RecentNewsWidget::widget() ?>

            <!--备忘录-->
            <?= \app\components\MemoWidget::widget() ?>

            <!--我的需求-->
            <?= \app\components\MyDemandWidget::widget() ?>

            <!--我的Bug-->
            <?= \app\components\MyBugWidget::widget() ?>
        </div>
    </div>
</div>

<?php $this->beginBlock('js') ?>
<script>
    $('.produce-list li').mouseover(function () {
        console.log($(this).attr('for'));
        $(this).siblings().removeClass('li_this');
        $(this).addClass('li_this');
        $('#product_detail').find('.product-detail-view').hide();
        $('#product_detail').find('#' + $(this).attr('for')).show();
    })
</script>
<?php $this->endBlock() ?>

views/site/update-password.php
<?php

?>

<div class="layui-fluid layui-anim layui-anim-fadein">
    <div class="layui-card">
        <div class="layui-card-header">
            <b>修改信息</b>
        </div>
        <div class="layui-card-body">
            <form class="layui-form" action="" method="post">
                <div class="layui-row">
                    <div class="layui-col-sm6">
                        <div class="layui-form-item">
                            <label class="layui-form-label must">姓名</label>
                            <div class="layui-input-block">
                                <input type="text" name="realname" lay-verify="required" placeholder="请输入姓名"
                                       autocomplete="off" class="layui-input" value="<?= $model->realname ?>">
                            </div>
                        </div>
                    </div>
                    <div class="layui-col-sm6">
                        <div class="layui-form-item">
                            <label class="layui-form-label">手机号</label>
                            <div class="layui-input-block">
                                <input type="text" name="mobile" placeholder="请输入手机号"
                                       autocomplete="off" class="layui-input" value="<?= $model->mobile ?>">
                            </div>
                        </div>
                    </div>
                </div>

                <div class="layui-row">
                    <div class="layui-col-sm6">
                        <div class="layui-form-item">
                            <label class="layui-form-label">QQ号</label>
                            <div class="layui-input-block">
                                <input type="text" name="qq" placeholder="请输入QQ号"
                                       autocomplete="off" class="layui-input" value="<?= $model->qq ?>">
                            </div>
                        </div>
                    </div>
                    <div class="layui-col-sm6">
                        <div class="layui-form-item">
                            <label class="layui-form-label">微信号</label>
                            <div class="layui-input-block">
                                <input type="text" name="wechat" placeholder="请输入微信号"
                                       autocomplete="off" class="layui-input" value="<?= $model->wechat ?>">
                            </div>
                        </div>
                    </div>
                </div>

                <div class="layui-form-item">
                    <label class="layui-form-label">邮箱</label>
                    <div class="layui-input-block">
                        <input type="text" name="email" placeholder="请输入邮箱（邮箱用于任务指派通知）"
                               autocomplete="off" class="layui-input" value="<?= $model->email ?>">
                    </div>
                </div>

                <div class="layui-form-item">
                    <label class="layui-form-label">住址</label>
                    <div class="layui-input-block">
                        <textarea name="address" class="layui-textarea"
                                  placeholder="请输入住址"><?= $model->address ?></textarea>
                    </div>
                </div>

                <div class="layui-form-item">
                    <label class="layui-form-label">密码</label>
                    <div class="layui-input-block">
                        <input type="password" name="password_hash" placeholder="若为空则不修改密码"
                               autocomplete="off" class="layui-input">
                    </div>
                </div>

                <div class="layui-form-item">
                    <label class="layui-form-label">确认密码</label>
                    <div class="layui-input-block">
                        <input type="password" name="password_confirm" placeholder="若为空则不修改密码"
                               autocomplete="off" class="layui-input">
                    </div>
                </div>

                <div class="layui-form-item">
                    <div class="layui-input-block">
                        <button class="layui-btn layui-btn-normal layui-btn-sm ajax-submit" lay-submit
                                lay-filter="submit" after-success="jump">立即提交
                        </button>
                    </div>
                </div>
            </form>
        </div>
    </div>
</div>

<?php $this->beginBlock('js') ?>

<?php $this->endBlock() ?>